"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import ...thirdparty.kfpbackend.resource_reference_pb2
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class CreateExperimentRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    EXPERIMENT_FIELD_NUMBER: builtins.int
    @property
    def experiment(self) -> global___Experiment:
        """The experiment to be created."""
        pass
    def __init__(self,
        *,
        experiment: typing.Optional[global___Experiment] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["experiment",b"experiment"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["experiment",b"experiment"]) -> None: ...
global___CreateExperimentRequest = CreateExperimentRequest

class GetExperimentRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ID_FIELD_NUMBER: builtins.int
    id: typing.Text
    """The ID of the experiment to be retrieved."""

    def __init__(self,
        *,
        id: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id",b"id"]) -> None: ...
global___GetExperimentRequest = GetExperimentRequest

class ListExperimentsRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    PAGE_SIZE_FIELD_NUMBER: builtins.int
    SORT_BY_FIELD_NUMBER: builtins.int
    FILTER_FIELD_NUMBER: builtins.int
    RESOURCE_REFERENCE_KEY_FIELD_NUMBER: builtins.int
    page_token: typing.Text
    """A page token to request the next page of results. The token is acquried
    from the nextPageToken field of the response from the previous
    ListExperiment call or can be omitted when fetching the first page.
    """

    page_size: builtins.int
    """The number of experiments to be listed per page. If there are more
    experiments than this number, the response message will contain a
    nextPageToken field you can use to fetch the next page.
    """

    sort_by: typing.Text
    """Can be format of "field_name", "field_name asc" or "field_name desc"
    Ascending by default.
    """

    filter: typing.Text
    """A url-encoded, JSON-serialized Filter protocol buffer (see
    [filter.proto](https://github.com/kubeflow/pipelines/blob/master/backend/api/filter.proto)).
    """

    @property
    def resource_reference_key(self) -> thirdparty.kfpbackend.resource_reference_pb2.ResourceKey:
        """What resource reference to filter on.
        For Experiment, the only valid resource type is Namespace. An sample query string could be
        resource_reference_key.type=NAMESPACE&resource_reference_key.id=ns1
        """
        pass
    def __init__(self,
        *,
        page_token: typing.Text = ...,
        page_size: builtins.int = ...,
        sort_by: typing.Text = ...,
        filter: typing.Text = ...,
        resource_reference_key: typing.Optional[thirdparty.kfpbackend.resource_reference_pb2.ResourceKey] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["resource_reference_key",b"resource_reference_key"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["filter",b"filter","page_size",b"page_size","page_token",b"page_token","resource_reference_key",b"resource_reference_key","sort_by",b"sort_by"]) -> None: ...
global___ListExperimentsRequest = ListExperimentsRequest

class ListExperimentsResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    EXPERIMENTS_FIELD_NUMBER: builtins.int
    TOTAL_SIZE_FIELD_NUMBER: builtins.int
    NEXT_PAGE_TOKEN_FIELD_NUMBER: builtins.int
    @property
    def experiments(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Experiment]:
        """A list of experiments returned."""
        pass
    total_size: builtins.int
    """The total number of experiments for the given query."""

    next_page_token: typing.Text
    """The token to list the next page of experiments."""

    def __init__(self,
        *,
        experiments: typing.Optional[typing.Iterable[global___Experiment]] = ...,
        total_size: builtins.int = ...,
        next_page_token: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["experiments",b"experiments","next_page_token",b"next_page_token","total_size",b"total_size"]) -> None: ...
global___ListExperimentsResponse = ListExperimentsResponse

class DeleteExperimentRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ID_FIELD_NUMBER: builtins.int
    id: typing.Text
    """The ID of the experiment to be deleted."""

    def __init__(self,
        *,
        id: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id",b"id"]) -> None: ...
global___DeleteExperimentRequest = DeleteExperimentRequest

class Experiment(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    class _StorageState:
        ValueType = typing.NewType('ValueType', builtins.int)
        V: typing_extensions.TypeAlias = ValueType
    class _StorageStateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Experiment._StorageState.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        STORAGESTATE_UNSPECIFIED: Experiment._StorageState.ValueType  # 0
        STORAGESTATE_AVAILABLE: Experiment._StorageState.ValueType  # 1
        STORAGESTATE_ARCHIVED: Experiment._StorageState.ValueType  # 2
    class StorageState(_StorageState, metaclass=_StorageStateEnumTypeWrapper):
        pass

    STORAGESTATE_UNSPECIFIED: Experiment.StorageState.ValueType  # 0
    STORAGESTATE_AVAILABLE: Experiment.StorageState.ValueType  # 1
    STORAGESTATE_ARCHIVED: Experiment.StorageState.ValueType  # 2

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    CREATED_AT_FIELD_NUMBER: builtins.int
    RESOURCE_REFERENCES_FIELD_NUMBER: builtins.int
    STORAGE_STATE_FIELD_NUMBER: builtins.int
    id: typing.Text
    """Output. Unique experiment ID. Generated by API server."""

    name: typing.Text
    """Required input field. Unique experiment name provided by user."""

    description: typing.Text
    """Optional input field. Describing the purpose of the experiment"""

    @property
    def created_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Output. The time that the experiment created."""
        pass
    @property
    def resource_references(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[thirdparty.kfpbackend.resource_reference_pb2.ResourceReference]:
        """Optional input field. Specify which resource this run belongs to.
        For Experiment, the only valid resource reference is a single Namespace.
        """
        pass
    storage_state: global___Experiment.StorageState.ValueType
    """Output. Specifies whether this experiment is in archived or available state."""

    def __init__(self,
        *,
        id: typing.Text = ...,
        name: typing.Text = ...,
        description: typing.Text = ...,
        created_at: typing.Optional[google.protobuf.timestamp_pb2.Timestamp] = ...,
        resource_references: typing.Optional[typing.Iterable[thirdparty.kfpbackend.resource_reference_pb2.ResourceReference]] = ...,
        storage_state: global___Experiment.StorageState.ValueType = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["created_at",b"created_at"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["created_at",b"created_at","description",b"description","id",b"id","name",b"name","resource_references",b"resource_references","storage_state",b"storage_state"]) -> None: ...
global___Experiment = Experiment

class ArchiveExperimentRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ID_FIELD_NUMBER: builtins.int
    id: typing.Text
    """The ID of the experiment to be archived."""

    def __init__(self,
        *,
        id: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id",b"id"]) -> None: ...
global___ArchiveExperimentRequest = ArchiveExperimentRequest

class UnarchiveExperimentRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor
    ID_FIELD_NUMBER: builtins.int
    id: typing.Text
    """The ID of the experiment to be restored."""

    def __init__(self,
        *,
        id: typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id",b"id"]) -> None: ...
global___UnarchiveExperimentRequest = UnarchiveExperimentRequest
